org.eclnt.jsfserver.elements

## Class ComponentRepository

- java.lang.Object
- - org.eclnt.jsfserver.elements.ComponentRepository

- All Implemented Interfaces:
    CLogConstants

      public class ComponentRepository
      extends java.lang.Object
      implements CLogConstants

  Central class for keeping meta data for each component. The meta data is used within the generic processing of `BaseComponent` and `BaseComponentTag`.
  For each tag library definition with corresponding prefix there is one instance which can be reached using the getInstance() method, passing the prefix of the tag library as parameter.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ComponentRepository.ComponentInfo` Certain information about a component which is required in...
    `static class` | `ComponentRepository.TLDInfo`

  - ### Field Summary

    - ### Fields inherited from interface org.eclnt.util.log.CLogConstants

      `LL_DBG, LL_ERR, LL_INF, LL_WAR`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static boolean` | `checkIfAttributeIsAReference(java.lang.String attrName)` Certain attributes represent a link to a file that is kept inside the web application.
    `static boolean` | `checkIfAttributeIsCCDefault(java.lang.String attrName)` Certain attributes are general CaptainCasa attributes that are applied to most of the components - without any rendering aspect.
    `static boolean` | `checkIfAttributeNameIsServerOnly(java.lang.String attrName)` Certain attributes of a tag are never transferred to the client, because they are for server side use only.
    `static boolean` | `checkIfControlLibraryIsRegistered(java.lang.String prefix)`
    `static boolean` | `checkIfKeyIsAnAction(java.lang.String key)`
    `ComponentRepository.ComponentInfo` | `getComponentInfo(java.lang.String tag)`
    `java.util.Collection<ComponentRepository.ComponentInfo>` | `getComponentInfos()` Get information on all components that are part of the control library.
    `static ComponentRepository` | `getDesignTimeInstance(java.lang.String prefix)`
    `static ComponentRepository.TLDInfo[]` | `getDesignTimeTLDInfos()`
    `static ComponentRepository.TLDInfo[]` | `getDesignTimeTLDInfosTFIRST()` Read all libraries, return the default t: library as the first one
    `static ComponentRepository` | `getInstance(java.lang.String prefix)` Factory for repositories.
    `static ComponentRepository.TLDInfo` | `getRunTimeTLDInfo(java.lang.String prefix)` Read TLD info for prefix.
    `static ComponentRepository.TLDInfo[]` | `getRunTimeTLDInfos()`
    `static ComponentRepository.TLDInfo[]` | `getRunTimeTLDInfosTFIRST()` Read all libraries, return the default t: library as the first one
    `static java.lang.String[]` | `getTagNameForComponentClass(java.lang.Class componentClass)`
    `static java.lang.String[]` | `getTagNameForComponentTagClass(java.lang.Class componentTagClass)`
    `static ComponentRepository.TLDInfo` | `getTLDInfo(java.lang.String prefix)` Get basic information about a registered tag library.
    `static void` | `registerDesignTimeLibrary(ProjectInfo.DesignTimeTLDInfo info)`
    `static void` | `registerLibrary(ComponentRepository.TLDInfo info)` Registration of libraries that are used within the CaptainCasa component processing.
    `static void` | `registerServerOnlyAttribute(java.lang.String attribute)` Register attribute which is never send to the client processing.
    `static void` | `unregisterAllDesignTimeLibraries()` Unregisters all extended libraries - this function is used within the editor environment.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### registerLibrary

          public static void registerLibrary(ComponentRepository.TLDInfo info)

      Registration of libraries that are used within the CaptainCasa component processing.
      Parameters:
        `prefix` - Prefix of the library, e.g. "t".

    - #### registerDesignTimeLibrary

          public static void registerDesignTimeLibrary(ProjectInfo.DesignTimeTLDInfo info)

    - #### unregisterAllDesignTimeLibraries

          public static void unregisterAllDesignTimeLibraries()

      Unregisters all extended libraries - this function is used within the editor environment.

    - #### getTLDInfo

          public static ComponentRepository.TLDInfo getTLDInfo(java.lang.String prefix)

      Get basic information about a registered tag library.

    - #### getRunTimeTLDInfos

          public static ComponentRepository.TLDInfo[] getRunTimeTLDInfos()

    - #### getDesignTimeTLDInfos

          public static ComponentRepository.TLDInfo[] getDesignTimeTLDInfos()

    - #### getRunTimeTLDInfo

          public static ComponentRepository.TLDInfo getRunTimeTLDInfo(java.lang.String prefix)

      Read TLD info for prefix.

    - #### getRunTimeTLDInfosTFIRST

          public static ComponentRepository.TLDInfo[] getRunTimeTLDInfosTFIRST()

      Read all libraries, return the default t: library as the first one

    - #### getDesignTimeTLDInfosTFIRST

          public static ComponentRepository.TLDInfo[] getDesignTimeTLDInfosTFIRST()

      Read all libraries, return the default t: library as the first one

    - #### registerServerOnlyAttribute

          public static void registerServerOnlyAttribute(java.lang.String attribute)

      Register attribute which is never send to the client processing. Pay attention: all attributes are valid for all component libraries which are registered!

    - #### getInstance

          public static ComponentRepository getInstance(java.lang.String prefix)

      Factory for repositories. Per tag library there is one repository instance.

    - #### getDesignTimeInstance

          public static ComponentRepository getDesignTimeInstance(java.lang.String prefix)

    - #### checkIfControlLibraryIsRegistered

          public static boolean checkIfControlLibraryIsRegistered(java.lang.String prefix)

    - #### getComponentInfo

          public ComponentRepository.ComponentInfo getComponentInfo(java.lang.String tag)

    - #### getComponentInfos

          public java.util.Collection<ComponentRepository.ComponentInfo> getComponentInfos()

      Get information on all components that are part of the control library.

    - #### getTagNameForComponentClass

          public static java.lang.String[] getTagNameForComponentClass(java.lang.Class componentClass)

      Returns:
        String[0] ==> prefix String[1] ==> tagName

    - #### getTagNameForComponentTagClass

          public static java.lang.String[] getTagNameForComponentTagClass(java.lang.Class componentTagClass)

      Returns:
        String[0] ==> prefix String[1] ==> tagName

    - #### checkIfKeyIsAnAction

          public static boolean checkIfKeyIsAnAction(java.lang.String key)

    - #### checkIfAttributeNameIsServerOnly

          public static boolean checkIfAttributeNameIsServerOnly(java.lang.String attrName)

      Certain attributes of a tag are never transferred to the client, because they are for server side use only. You can update the attibutes not transferred to the server by using the method registerServerOnlyAttribute().

    - #### checkIfAttributeIsAReference

          public static boolean checkIfAttributeIsAReference(java.lang.String attrName)

      Certain attributes represent a link to a file that is kept inside the web application. Example: references to images. These need to be identified in order to update relative references when working with page includes (ROWINCLUDE component).

    - #### checkIfAttributeIsCCDefault

          public static boolean checkIfAttributeIsCCDefault(java.lang.String attrName)

      Certain attributes are general CaptainCasa attributes that are applied to most of the components - without any rendering aspect.

Copyright © CaptainCasa Gmbh. All Rights Reserved.